/*******************************************************************************
* File Name: cyfitter_amux.c
* 
* PSoC Creator  4.3
*
* Description:
* APIs for analog mux channel switching
* This file is automatically generated by PSoC Creator.
*
********************************************************************************
* Copyright (c) 2007-2019 Cypress Semiconductor.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include "cyfitter_cfg.h"
#include "cydevice_trm.h"
#include <string.h>

#if defined(__GNUC__) || defined(__ARMCC_VERSION)
    #define CYPACKED 
    #define CYPACKED_ATTR __attribute__ ((packed))
    #define CYALIGNED __attribute__ ((aligned))
    #define CY_CFG_UNUSED __attribute__ ((unused))
    #ifndef CY_CFG_SECTION
        #define CY_CFG_SECTION __attribute__ ((section(".psocinit")))
    #endif
    
    #if defined(__ARMCC_VERSION)
        #define CY_CFG_MEMORY_BARRIER() __memory_changed()
    #else
        #define CY_CFG_MEMORY_BARRIER() __sync_synchronize()
    #endif
    
#elif defined(__ICCARM__)
    #include <intrinsics.h>

    #define CYPACKED __packed
    #define CYPACKED_ATTR 
    #define CYALIGNED _Pragma("data_alignment=4")
    #define CY_CFG_UNUSED _Pragma("diag_suppress=Pe177")
    #define CY_CFG_SECTION _Pragma("location=\".psocinit\"")
    
    #define CY_CFG_MEMORY_BARRIER() __DMB()
    
#else
    #error Unsupported toolchain
#endif

#ifndef CYCODE
    #define CYCODE
#endif
#ifndef CYDATA
    #define CYDATA
#endif
#ifndef CYFAR
    #define CYFAR
#endif
#ifndef CYXDATA
    #define CYXDATA
#endif


CY_CFG_UNUSED
static void CYMEMZERO(void *s, size_t n);
CY_CFG_UNUSED
static void CYMEMZERO(void *s, size_t n)
{
	(void)memset(s, 0, n);
}
CY_CFG_UNUSED
static void CYCONFIGCPY(void *dest, const void *src, size_t n);
CY_CFG_UNUSED
static void CYCONFIGCPY(void *dest, const void *src, size_t n)
{
	(void)memcpy(dest, src, n);
}
CY_CFG_UNUSED
static void CYCONFIGCPYCODE(void *dest, const void *src, size_t n);
CY_CFG_UNUSED
static void CYCONFIGCPYCODE(void *dest, const void *src, size_t n)
{
	(void)memcpy(dest, src, n);
}


#define CY_AMUX_UNUSED CYREG_CPUSS_CM0_STATUS
/*******************************************************************************
* Function Name: AMux_1_Set
********************************************************************************
* Summary:
*  This function is used to set a particular channel as active on the AMux.
*
* Parameters:  
*   channel - The mux channel input to set as active
*
* Return:
*   void
*
*******************************************************************************/
void AMux_1_Set(uint8 channel)
{
	switch (channel) {
		case 0u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH0, (0x40u));
			break;
		case 1u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH0, (0x10u));
			break;
		case 2u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH0, (0x80u));
			break;
		case 3u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH0, (0x20u));
			break;
		case 4u:
			CY_SET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5, (CY_GET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5) | 0x02u));
			CY_SET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5, (CY_GET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5) | 0x01u));
			break;
		default:
			break;
	}
}

/*******************************************************************************
* Function Name: AMux_1_Unset
********************************************************************************
* Summary:
*  This function is used to clear a particular channel from being active on the
*  AMux.
*
* Parameters:  
*   channel - The mux channel input to mark inactive
*
* Return:
*   void
*
*******************************************************************************/
void AMux_1_Unset(uint8 channel)
{
	switch (channel) {
		case 0u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH_CLEAR0, (0x40u));
			break;
		case 1u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH_CLEAR0, (0x10u));
			break;
		case 2u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH_CLEAR0, (0x80u));
			break;
		case 3u:
			CY_SET_REG32((void CYXDATA *)CYREG_SAR_MUX_SWITCH_CLEAR0, (0x20u));
			break;
		case 4u:
			CY_SET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5, (CY_GET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5) & 0xfffffffdu));
			CY_SET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5, (CY_GET_REG32((void CYXDATA *)CYREG_HSIOM_AMUX_SPLIT_CTL5) & 0xfffffffeu));
			break;
		default:
			break;
	}
}


